#include <SetupA4.h>

OSErr LocateFile(short refNum, FSSpec* location);

unsigned char cPatchName[] = "\pThink Helper Patch";

void main()
{
	short fRefNum;
	FSSpec thinkRef;

	RememberA0();
	
	SetUpA4();
		
	if (LocateFile(CurResFile(), &thinkRef) == noErr) {
		BlockMove(cPatchName, thinkRef.name, sizeof(cPatchName));

		fRefNum = FSpOpenResFile(&thinkRef, fsRdWrPerm);
		
		if (fRefNum != -1) {
			Handle h;
			
			UseResFile(fRefNum);
			
			h = Get1Resource('THLP', 128);
			
			if (h != nil) {
				DetachResource(h);
				MoveHHi(h);
				HLock(h);
				
				asm {
					move.l	h,a0
					move.l	(a0),d0
					_StripAddress
					move.l	d0,a0
					jsr		(a0)
				}
			}
			
			CloseResFile(fRefNum);
		}
	}
	
	SysBeep(2);

	RestoreA4();
}


OSErr LocateFile(short refNum, FSSpec* location)
{
	FCBPBRec fcbPB;
	OSErr result;

	fcbPB.ioNamePtr = (StringPtr)location->name;
	fcbPB.ioCompletion = nil;
	fcbPB.ioFCBIndx = 0;
	fcbPB.ioRefNum = refNum;
	result = PBGetFCBInfoSync(&fcbPB);
	if (result == noErr) {
		location->vRefNum = fcbPB.ioFCBVRefNum;
		location->parID = fcbPB.ioFCBParID;
	}

	return result;
}
